using System;

namespace RepPP.Toolkit.Window {
    //*********************************************************	    
    //
	/// <summary>
	/// Implement a toolbar with configured buttons tooltips
	/// </summary>
    //
    //*********************************************************	    
	public class ToolBarExt : System.Windows.Forms.ToolBar {
        private System.ComponentModel.Container     components = null;

        //*********************************************************	    
        //
        /// <summary>
        /// ctor:               Class constructor
        /// </summary>
        //
        //*********************************************************	    
        public ToolBarExt() {
            InitializeComponent();
        }

        //*********************************************************	    
        //
        /// <summary>
        /// Dispose:                     Dispose the treeview
        /// </summary>
        /// <param name="bDisposing">   true if dispose, false if GC</param>
        //
        //*********************************************************	    
        protected override void Dispose(bool bDisposing ) {
            if (bDisposing) {
                if (components != null) {
                    components.Dispose();
                }
            }
            base.Dispose(bDisposing);
        }

		#region Component Designer generated code
        /// <summary> 
        /// Required method for Designer support - do not modify 
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent() {
            components = new System.ComponentModel.Container();
        }
        #endregion

        //*********************************************************	    
        //
        /// <summary>
        /// WndProc:            Override the window proc to redraw the disable button correctly.
        /// </summary>
        /// <param name="msg">  Message</param>
        //	
        //*********************************************************	 
        protected override void WndProc(ref System.Windows.Forms.Message msg) {
            System.Drawing.Graphics gr;
            System.Windows.Forms.ImageList imageList;
            System.Drawing.Image img;
            int iIndex;

            base.WndProc(ref msg);
            if (msg.Msg == 15) {
                gr = CreateGraphics();
                foreach (System.Windows.Forms.ToolBarButton but in Buttons) {
                    if (!but.Enabled &&
                        but.Visible &&
                        but.Style == System.Windows.Forms.ToolBarButtonStyle.PushButton &&
                        but.ImageIndex != -1) {
                        imageList = but.Parent.ImageList;
                        if (imageList != null) {
                            iIndex = but.ImageIndex + imageList.Images.Count / 2;
                            if (iIndex < imageList.Images.Count) {
                                img = imageList.Images[iIndex];
                                gr.DrawImage(img, but.Rectangle.X + 4, but.Rectangle.Y + 3);
                            }
                        }
                    }
                }
                gr.Dispose();
            }
        }
    }
}
